from collections import namedtuple


ConstructionRequest = namedtuple("ConstructionRequest", ("settings, "
                                                         "algorithms,"
                                                         "interface,"
                                                         "mode"))


FeatureSelectionRequest = namedtuple("FeatureSelectionRequest",
                                     ("filter_method,"
                                      "embedded_method,"
                                      "settings"))


ReconstructionRequest = namedtuple("ReconstructionRequest", ("settings,"
                                                             "algorithms,"
                                                             "interface,"
                                                             "mode,"
                                                             "krippendorf"))

DeconstructionRequest = namedtuple("DeconstructionRequest",
                                   ("mode,"
                                    "general_settings,"
                                    "deconstruction_settings,"
                                    "density_estimator,"
                                    "block_processing_settings,"
                                    "build_block_from_rows,"
                                    "build_new_learnblock,"
                                    "reconstructor"))


KnowledgeSearchingRequest = namedtuple("KnowledgeSearchingRequest",
                                       ("general_settings,"
                                        "block_processing_settings,"
                                        "density_estimator,"
                                        "preprocessor_settings,"
                                        "df_converter,"
                                        "build_block_from_rows,"
                                        "constructor,"
                                        "feature_selector,"
                                        "reconstructor,"
                                        "deconstructor,"
                                        "knowledge,"
                                        "stdout,"
                                        "parallel,"
                                        "debug"))
